# Garmin - FIT C# SDK

## FIT SDK Documentation
The FIT SDK documentation is available at [https://developer.garmin.com/fit](https://developer.garmin.com/fit)
## FIT SDK Developer Forum
Share your knowledge, ask questions, and get the latest FIT SDK news in the [FIT SDK Developer Forum](https://forums.garmin.com/developer/)

## Install
The latest version of the SDK can be installed from [NuGet](https://www.nuget.org/packages/Garmin.FIT.Sdk)

```
dotnet add package Garmin.FIT.Sdk
```

## FIT SDK Cookbook
The [FIT SDK Cookbook](https://developer.garmin.com/fit/cookbook/) contains examples of using the FIT SDK to solve real-world problems. There are recipes for encoding and decoding Activity, Workout, and Course files; and recipes that provide tips for working with the FIT SDK.

### Decoding an Activity File
The FIT C# SDK contains example code for decoding FIT Activity files. See the [Decoding FIT Activity Files](https://developer.garmin.com/fit/cookbook/decoding-activity-files/) recipe for details on decoding FIT Activity files.

### Encoding an Activity File
The FIT C# SDK contains example code for encoding FIT Activity files. See the [Encoding FIT Activity Files](https://developer.garmin.com/fit/cookbook/encoding-activity-files/) recipe for details on encoding FIT Activity files.

### Encoding a Course File
The FIT C# SDK contains example code for encoding FIT Course files. See the [Encoding FIT Course Files](https://developer.garmin.com/fit/cookbook/encoding-course-files/) recipe for details on encoding FIT Course files.
### Encoding a Workout File
The FIT C# SDK contains example code for encoding FIT Workout files. See the [Encoding FIT Workout Files](https://developer.garmin.com/fit/cookbook/encoding-workout-files/) recipe for details on encoding FIT Workout files.